
/*
   Copyright (c) 2003-2007 Clarence Dang <dang@kde.org>
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

   1. Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
   OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
   IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
   NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
   THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef kpAbstractSelectionToolPrivate_H
#define kpAbstractSelectionToolPrivate_H

#include "kpAbstractSelectionTool.h"

#include <QPoint>


class QTimer;

class kpAbstractSelectionContentCommand;
class kpToolSelectionMoveCommand;
class kpToolSelectionResizeScaleCommand;
class kpToolWidgetOpaqueOrTransparent;


struct kpAbstractSelectionToolPrivate
{
    kpAbstractSelectionTool::DrawType drawType;
    kpAbstractSelectionContentCommand *currentSelContentCommand;

    // Whether the drag has been substantial enough to be considered as a
    // non-NOP drag.  The "substantial enough" critera is draw-type
    // dependent and is usually based on how far the mouse has been
    // dragged.  See kpAbstractSelectionTool's API Doc for details.
    bool dragAccepted;

    bool hadSelectionBeforeDraw;

    bool cancelledShapeButStillHoldingButtons;

    kpToolWidgetOpaqueOrTransparent *toolWidgetOpaqueOrTransparent;


    //
    // Create
    //

    QTimer *createNOPTimer;


    //
    // Move
    //

    kpToolSelectionMoveCommand *currentMoveCommand;
    bool currentMoveCommandIsSmear;

    QPoint startMoveDragFromSelectionTopLeft;

    QTimer *RMBMoveUpdateGUITimer;


    //
    // Resize / Scale
    //

    kpToolSelectionResizeScaleCommand *currentResizeScaleCommand;
    int resizeScaleType;
};


#endif  // kpAbstractSelectionToolPrivate_H
